#define COMMON
#define COMMON_VER 4.0

#include <conio.h>



struct side_menu_colors
{
  unsigned normal_highlight;
  unsigned normal_menu_item;
  unsigned current_highlight;
  unsigned current_menu_item;
};



struct search_record
{
  char filemask[13];

  long nscandate;

  char search[81];

  int alldirs;
  int search_extended;
};


typedef struct
{
  char name[31];          /* verify against a user */

  unsigned long status;

  unsigned long lp_options;
  unsigned char lp_colors[32];

  char junk[129];
} asylum_config;





/* INI STUFF */

#define AMOUNT_BOOLS (4)


/* longest ini line to be read in */
#define MAX_LINE_WIDTH (128)

#define INI_COL_WIDTH "-22"
#define INI_COMMENT_POS (40)

#define INI_FLAGS_NONE                   0x00000000
#define INI_FLAGS_SEE_THROUGH_COMMENTS   0x00000001
#define INI_FLAGS_SEE_THROUGH_ON_READ    0x00000002
#define INI_FLAGS_READ_ONLY              0x00000004
#define INI_FLAGS_WRITE_IF_NO_READ       0x00000008

#define IF_NONE  INI_FLAGS_NONE
#define IF_STC   INI_FLAGS_SEE_THROUGH_COMMENTS
#define IF_STCR  INI_FLAGS_SEE_THROUGH_ON_READ
#define IF_OREAD INI_FLAGS_READ_ONLY
#define IF_WINR  INI_FLAGS_WRITE_IF_NO_READ


#ifdef __OS2__
#define REALLOC realloc
#else
#define REALLOC farrealloc
#endif

#define MALLOC  malloca
#define FREE    bbsfree

#define FOPEN  fsh_open
#define FCLOSE fsh_close


extern char bool_strings[AMOUNT_BOOLS][2][8];



typedef struct
{
  char fname[131];
  char area[31];
  char **ini_rows;     /* a pointer to a row of pointers */
  unsigned amount_rows, rows_allocated;


  int amount_patt_idents;  /* used for finding duplicate identifiers   */
  int *patt_idents;        /* allocated in get_idents_positions, freed */
                           /* by function close_ini                    */

  int modified;
  unsigned long flags;
  FILE *fp;                /* ini file pointer */
}ini_record;


/* end INI stuff */
